Index: palm/trunk/SOURCE/check_open.f90
===================================================================
--- palm/trunk/SOURCE/check_open.f90	(revision 4901)
+++ palm/trunk/SOURCE/check_open.f90	(revision 1)
@@ -447,34 +418,272 @@
        CASE ( 30 )
 
-          OPEN ( 30, FILE='PLOT3D_DATA' // TRIM( coupling_char ) // myid_char, FORM='UNFORMATTED' )
-!
-!--       Specifications for combine_plot_fields
+
+#if defined( __t3eb ) || defined( __t3eh ) || defined( __t3ej5 )
+!
+!--       In case of active data compression 32Bit integer output
+          IF ( do3d_compress )  THEN
+             CALL ASNUNIT( 30, '-F f77 -N ieee_32', ierr1 )
+          ENDIF
+#endif
+
+          OPEN ( 30, FILE='PLOT3D_DATA'//myid_char, FORM='UNFORMATTED' )
+!
+!--       Write coordinate file for AVS
           IF ( myid == 0 )  THEN
 #if defined( __parallel )
-             WRITE ( 30 )  0, nx, 0, ny, 0, nz_do3d
-#endif
-          ENDIF
+!
+!--          Specifications for combine_plot_fields
+             IF ( .NOT. do3d_compress )  THEN
+                WRITE ( 30 )  -1,nx+1,-1,ny+1,0,nz_do3d
+                WRITE ( 30 )  0,nx+1,0,ny+1,0,nz_do3d
+             ENDIF
+#endif
+!
+!--          Write coordinate file for AVS:
+!--          First determine file names (including cyle numbers) of AVS files on
+!--          target machine (to which the files are to be transferred).
+!--          Therefore path information has to be obtained first.
+             IF ( avs_output )  THEN
+                CALL local_getenv( 'return_addres', 13, return_addres, iaddres )
+                CALL local_getenv( 'return_username', 15, return_usern, iusern )
+
+                OPEN ( 3, FILE='OUTPUT_FILE_CONNECTIONS', FORM='FORMATTED' )
+                DO  WHILE ( .NOT. avs_coor_file_found  .OR. &
+                            .NOT. avs_data_file_found )
+
+                   READ ( 3, '(A)', END=1 )  zeile
+
+                   SELECT CASE ( zeile(1:11) )
+
+                      CASE ( 'PLOT3D_COOR' )
+                         READ ( 3, '(A/A)' )  avs_coor_file_catalog, &
+                                              avs_coor_file_localname
+                         avs_coor_file_found = .TRUE.
+
+                      CASE ( 'PLOT3D_DATA' )
+                         READ ( 3, '(A/A)' )  avs_data_file_catalog, &
+                                              avs_data_file_localname
+                         avs_data_file_found = .TRUE.
+
+                      CASE DEFAULT
+                         READ ( 3, '(A/A)' )  zeile, zeile
+
+                   END SELECT
+
+                ENDDO
+!
+!--             Now the cycle numbers on the remote machine must be obtained
+!--             using batch_scp
+       1        CLOSE ( 3 )
+                IF ( .NOT. avs_coor_file_found  .OR. &
+                     .NOT. avs_data_file_found )  THEN
+                   PRINT*, '+++ check_open: no filename for AVS-data-file ', &
+                             'found in MRUN-config-file'
+                   PRINT*, '                filename in FLD-file set to ', &
+                             '"unknown"'
+
+                   avs_coor_file = 'unknown'
+                   avs_data_file = 'unknown'
+                ELSE
+                   get_filenames = .TRUE.
+                   IF ( TRIM( host ) == 'hpmuk'  .OR.  &
+                        TRIM( host ) == 'lcmuk' )  THEN
+                      batch_scp = '/home/raasch/pub/batch_scp'
+                   ELSEIF ( TRIM( host ) == 'nech' )  THEN
+                      batch_scp = '/ipf/b/b323011/pub/batch_scp'
+                   ELSEIF ( TRIM( host ) == 'ibmh'  .OR.  &
+                            TRIM( host ) == 'ibmb' )  THEN
+                      batch_scp = '/home/h/niksiraa/pub/batch_scp'
+                   ELSEIF ( TRIM( host ) == 't3eb' )  THEN
+                      batch_scp = '/home/nhbksira/pub/batch_scp'
+                   ELSE
+                      PRINT*,'+++ check_open: no path for batch_scp on host "',&
+                             TRIM( host ), '"'
+                      get_filenames = .FALSE.
+                   ENDIF
+
+                   IF ( get_filenames )  THEN
+!
+!--                   Determine the coordinate file name.
+!--                   /etc/passwd serves as Dummy-Datei, because it is not 
+!--                   really transferred.
+                      command = TRIM( batch_scp ) // ' -n -u ' // &
+                         return_usern(1:iusern) // ' ' // &
+                         return_addres(1:iaddres) // ' /etc/passwd "' // &
+                         TRIM( avs_coor_file_catalog ) // '" ' // &
+                         TRIM( avs_coor_file_localname ) // ' > REMOTE_FILENAME'
+
+                      CALL local_system( command )
+                      OPEN ( 3, FILE='REMOTE_FILENAME', FORM='FORMATTED' )
+                      READ ( 3, '(A)' )  avs_coor_file
+                      CLOSE ( 3 )
+!
+!--                   Determine the data file name
+                      command = TRIM( batch_scp ) // ' -n -u ' // &
+                         return_usern(1:iusern) // ' ' // &
+                         return_addres(1:iaddres) // ' /etc/passwd "' // &
+                         TRIM( avs_data_file_catalog ) // '" ' // &
+                         TRIM( avs_data_file_localname ) // ' > REMOTE_FILENAME'
+
+                      CALL local_system( command )
+                      OPEN ( 3, FILE='REMOTE_FILENAME', FORM='FORMATTED' )
+                      READ ( 3, '(A)' )  avs_data_file
+                      CLOSE ( 3 )
+
+                   ELSE
+
+                      avs_coor_file = 'unknown'
+                      avs_data_file = 'unknown'
+
+                   ENDIF
+
+                ENDIF
+
+!
+!--             Output of the coordinate file description for FLD-file
+                OPEN ( 33, FILE='PLOT3D_FLD_COOR', FORM='FORMATTED' )
+                openfile(33)%opened = .TRUE.
+                WRITE ( 33, 3300 )  TRIM( avs_coor_file ), &
+                                    TRIM( avs_coor_file ), (nx+2)*4, &
+                                    TRIM( avs_coor_file ), (nx+2)*4+(ny+2)*4
+            
+
+                ALLOCATE( xkoor(0:nx+1), ykoor(0:ny+1), zkoor(0:nz_do3d) )
+                DO  i = 0, nx+1
+                   xkoor(i) = i * dx
+                ENDDO
+                DO  j = 0, ny+1
+                   ykoor(j) = j * dy
+                ENDDO
+                DO  k = 0, nz_do3d
+                   zkoor(k) = zu(k)
+                ENDDO
+
+!
+!--             Create and write on AVS coordinate file
+                OPEN ( 31, FILE='PLOT3D_COOR', FORM='UNFORMATTED' )
+                openfile(31)%opened = .TRUE.
+
+                WRITE (31)  xkoor, ykoor, zkoor
+                DEALLOCATE( xkoor, ykoor, zkoor )
+
+!
+!--             Create FLD file (being written on in close_file)
+                OPEN ( 32, FILE='PLOT3D_FLD', FORM='FORMATTED' )
+                openfile(32)%opened = .TRUE.
+
+!
+!--             Create flag file for compressed 3D output,
+!--             influences output commands in mrun
+                IF ( do3d_compress )  THEN
+                   OPEN ( 3, FILE='PLOT3D_COMPRESSED', FORM='FORMATTED' )
+                   WRITE ( 3, '(1X)' )
+                   CLOSE ( 3 )
+                ENDIF 
+
+             ENDIF
+
+          ENDIF
+
+!
+!--       In case of data compression output of the coordinates of the
+!--       corresponding partial array of a PE only once at the top of the file
+          IF ( avs_output  .AND.  do3d_compress )  THEN
+             WRITE ( 30 )  nxl-1, nxr+1, nys-1, nyn+1, nzb, nz_do3d
+          ENDIF
+
+       CASE ( 40:49 )
+
+          IF ( statistic_regions == 0  .AND.  file_id == 40 )  THEN
+             suffix = ''
+          ELSE
+             WRITE ( suffix, '(''_'',I1)' )  file_id - 40
+          ENDIF
+          OPEN ( file_id, FILE='PLOT1D_DATA'//TRIM( suffix ), FORM='FORMATTED' )
+!
+!--       Write contents comments at the top of the file
+          WRITE ( file_id, 4000 )  TRIM( run_description_header ) // '    ' // &
+                                   TRIM( region( file_id - 40 ) )
+
+       CASE ( 50:59 )
+
+          IF ( statistic_regions == 0  .AND.  file_id == 50 )  THEN
+             suffix = ''
+          ELSE
+             WRITE ( suffix, '(''_'',I1)' )  file_id - 50
+          ENDIF
+          OPEN ( file_id, FILE='PLOTTS_DATA'//TRIM( suffix ), FORM='FORMATTED',&
+                          RECL=496 )
+!
+!--       Write PROFIL parameter file for output of time series
+!--       NOTE: To be on the safe side, this output is done at the beginning of
+!--             the model run (in case of collapse) and it is repeated in
+!--             close_file, then, however, with value ranges for the coordinate
+!--             systems
+!
+!--       Firstly determine the number of the coordinate systems to be drawn
+          cranz = 0
+          DO  j = 1, 10
+             IF ( cross_ts_number_count(j) /= 0 )  cranz = cranz+1
+          ENDDO
+          rtext = '\1.0 ' // TRIM( run_description_header ) // '    ' // &
+                  TRIM( region( file_id - 50 ) )
+!
+!--       Write RAHMEN parameter
+          OPEN ( 90, FILE='PLOTTS_PAR'//TRIM( suffix ), FORM='FORMATTED', &
+                     DELIM='APOSTROPHE' )
+          WRITE ( 90, RAHMEN )
+!
+!--       Determine and write CROSS parameters for the individual coordinate 
+!--       systems
+          DO  j = 1, 10
+             k = cross_ts_number_count(j)
+             IF ( k /= 0 )  THEN
+!
+!--             Store curve numbers, colours and line style
+                klist(1:k) = cross_ts_numbers(1:k,j)
+                klist(k+1:10) = 999999
+                cucol(1:k) = linecolors(1:k)
+                lstyle(1:k) = linestyles(1:k)
+!
+!--             Write CROSS parameter
+                WRITE ( 90, CROSS )
+
+             ENDIF
+          ENDDO
+
+          CLOSE ( 90 )
+!
+!--       Write all labels at the top of the data file, but only during the 
+!--       first run of a sequence of jobs. The following jobs copy the time
+!--       series data to the bottom of that file.
+          IF ( runnr == 0 )  THEN
+             WRITE ( file_id, 5000 )  TRIM( run_description_header ) // &
+                                      '    ' // TRIM( region( file_id - 50 ) )
+          ENDIF
+
 
        CASE ( 80 )
 
           IF ( myid_char == '' )  THEN
-             OPEN ( 80, FILE='PARTICLE_INFOS'//TRIM(coupling_char)//myid_char, FORM='FORMATTED',   &
+             OPEN ( 80, FILE='PARTICLE_INFOS'//myid_char, FORM='FORMATTED', &
                         POSITION='APPEND' )
           ELSE
              IF ( myid == 0  .AND.  .NOT. openfile(80)%opened_before )  THEN
-                CALL local_system( 'mkdir  PARTICLE_INFOS' // TRIM( coupling_char ) )
+                CALL local_system( 'mkdir  PARTICLE_INFOS' )
              ENDIF
 #if defined( __parallel )
 !
-!--          Set a barrier in order to allow that thereafter all other processors in the directory
-!--          created by PE0 can open their file.
-!--          WARNING: The following barrier will lead to hanging jobs, if check_open is first called
-!--                   from routine allocate_prt_memory!
+!--          Set a barrier in order to allow that thereafter all other
+!--          processors in the directory created by PE0 can open their file.
+!--          WARNING: The following barrier will lead to hanging jobs, if
+!--                   check_open is first called from routine
+!--                   allocate_prt_memory!
              IF ( .NOT. openfile(80)%opened_before )  THEN
                 CALL MPI_BARRIER( comm2d, ierr )
              ENDIF
 #endif
-             OPEN ( 80, FILE='PARTICLE_INFOS' // TRIM( coupling_char ) // '/' // myid_char,        &
-                        FORM='FORMATTED', POSITION='APPEND' )
+             OPEN ( 80, FILE='PARTICLE_INFOS/'//myid_char, FORM='FORMATTED', &
+                        POSITION='APPEND' )
           ENDIF
 
@@ -483,30 +692,41 @@
           ENDIF
 
+       CASE ( 81 )
+
+             OPEN ( 81, FILE='PLOTSP_X_PAR', FORM='FORMATTED', &
+                        DELIM='APOSTROPHE', RECL=1500, POSITION='APPEND' )
+
+       CASE ( 82 )
+
+             OPEN ( 82, FILE='PLOTSP_X_DATA', FORM='FORMATTED', &
+                        POSITION = 'APPEND' )
+
+       CASE ( 83 )
+
+             OPEN ( 83, FILE='PLOTSP_Y_PAR', FORM='FORMATTED', &
+                        DELIM='APOSTROPHE', RECL=1500, POSITION='APPEND' )
+
+       CASE ( 84 )
+
+             OPEN ( 84, FILE='PLOTSP_Y_DATA', FORM='FORMATTED', &
+                        POSITION='APPEND' )
+
        CASE ( 85 )
 
           IF ( myid_char == '' )  THEN
-             OPEN ( 85, FILE='PARTICLE_DATA' // TRIM(coupling_char) // myid_char,                  &
-                        FORM='UNFORMATTED', POSITION='APPEND' )
+             OPEN ( 85, FILE='PARTICLE_DATA'//myid_char, FORM='UNFORMATTED', &
+                        POSITION='APPEND' )
           ELSE
              IF ( myid == 0  .AND.  .NOT. openfile(85)%opened_before )  THEN
-                CALL local_system( 'mkdir  PARTICLE_DATA' // TRIM( coupling_char ) )
+                CALL local_system( 'mkdir  PARTICLE_DATA' )
              ENDIF
 #if defined( __parallel )
 !
-!--          Set a barrier in order to allow that thereafter all other processors in the directory
-!--          created by PE0 can open their file
+!--          Set a barrier in order to allow that thereafter all other
+!--          processors in the directory created by PE0 can open their file
              CALL MPI_BARRIER( comm2d, ierr )
 #endif
-             ioerr = 1
-             DO WHILE ( ioerr /= 0 )
-                OPEN ( 85, FILE='PARTICLE_DATA' // TRIM( coupling_char ) // '/' // myid_char,      &
-                           FORM='UNFORMATTED', POSITION='APPEND', IOSTAT=ioerr )
-                IF ( ioerr /= 0 )  THEN
-                   WRITE( 9, * )  '*** could not open "PARTICLE_DATA' // TRIM( coupling_char ) //  &
-                                  '/' // myid_char // '"! Trying again in 1 sec.'
-                   CALL fortran_sleep( 1 )
-                ENDIF
-             ENDDO
-
+             OPEN ( 85, FILE='PARTICLE_DATA/'//myid_char, FORM='UNFORMATTED', &
+                        POSITION='APPEND' )
           ENDIF
 
@@ -514,61 +734,12 @@
              WRITE ( 85 )  run_description_header
 !
-!--          Attention: change version number whenever the output format on unit 85 is changed (see
-!--                     also in routine lpm_data_output_particles)
-             rtext = 'data format version 3.1'
+!--          Attention: change version number whenever the output format on
+!--                     unit 85 is changed (see also in routine advec_particles)
+             rtext = 'data format version 3.0'
              WRITE ( 85 )  rtext
-             WRITE ( 85 )  number_of_particle_groups, max_number_of_particle_groups
+             WRITE ( 85 )  number_of_particle_groups, &
+                           max_number_of_particle_groups
              WRITE ( 85 )  particle_groups
-             WRITE ( 85 )  nxl, nxr, nys, nyn, nzb, nzt, nbgp
-          ENDIF
-
-!
-!--    File where sky-view factors and further required data is stored will be read
-       CASE ( 88 )
-
-          IF ( myid_char == '' )  THEN
-             OPEN ( 88, FILE='SVFIN' // TRIM( coupling_char ) // myid_char, FORM='UNFORMATTED',    &
-                        STATUS='OLD', IOSTAT=ioerr )
-          ELSE
-
-             OPEN ( 88, FILE='SVFIN' // TRIM( coupling_char ) // '/' // myid_char,                 &
-                        FORM='UNFORMATTED', STATUS='OLD', IOSTAT=ioerr )
-          ENDIF
-
-!
-!--    File where sky-view factors and further required data is stored will be created
-       CASE ( 89 )
-
-          IF ( myid_char == '' )  THEN
-             OPEN ( 89, FILE='SVFOUT' // TRIM( coupling_char ) // myid_char, FORM='UNFORMATTED',   &
-                        STATUS='NEW' )
-          ELSE
-             IF ( myid == 0  .AND.  .NOT. openfile(file_id)%opened_before )  THEN
-                CALL local_system( 'mkdir  SVFOUT' // TRIM( coupling_char ) )
-             ENDIF
-#if defined( __parallel )
-!
-!--          Set a barrier in order to allow that all other processors in the directory created by
-!--          PE0 can open their file
-             CALL MPI_BARRIER( comm2d, ierr )
-#endif
-             ioerr = 1
-             DO WHILE ( ioerr /= 0 )
-                OPEN ( 89, FILE='SVFOUT' // TRIM( coupling_char ) // '/' // myid_char,             &
-                           FORM='UNFORMATTED', STATUS='NEW', IOSTAT=ioerr )
-                IF ( ioerr /= 0 )  THEN
-                   WRITE( 9, * )  '*** could not open "SVFOUT' // TRIM( coupling_char ) // '/' //  &
-                                  myid_char // '"! Trying again in 1 sec.'
-                   CALL fortran_sleep( 1 )
-                ENDIF
-             ENDDO
-
-          ENDIF
-
-!
-!--    Progress file that is used by the PALM watchdog
-       CASE ( 117 )
-
-          OPEN ( 117, FILE='PROGRESS' // TRIM( coupling_char ), STATUS='REPLACE', FORM='FORMATTED' )
+          ENDIF
 
 #if defined( __netcdf )
@@ -577,22 +748,26 @@
 !--       Set filename depending on unit number
           IF ( file_id == 101 )  THEN
-             filename = 'DATA_2D_XY_NETCDF' // TRIM( coupling_char )
+             filename = 'DATA_2D_XY_NETCDF'
              av = 0
           ELSE
-             filename = 'DATA_2D_XY_AV_NETCDF' // TRIM( coupling_char )
+             filename = 'DATA_2D_XY_AV_NETCDF'
              av = 1
           ENDIF
 !
-!--       Inquire, if there is a netCDF file from a previous run. This should be opened for
-!--       extension, if its dimensions and variables match the actual run.
+!--       Inquire, if there is a NetCDF file from a previuos run. This should
+!--       be opened for extension, if its dimensions and variables match the
+!--       actual run.
           INQUIRE( FILE=filename, EXIST=netcdf_extend )
+
           IF ( netcdf_extend )  THEN
 !
-!--          Open an existing netCDF file for output
-             CALL netcdf_open_write_file( filename, id_set_xy(av), .TRUE., 20 )
-!
-!--          Read header information and set all ids. If there is a mismatch between the previous
-!--          and the actual run, netcdf_extend is returned as .FALSE.
-             CALL netcdf_define_header( 'xy', netcdf_extend, av )
+!--          Open an existing NetCDF file for output 
+             nc_stat = NF90_OPEN( filename, NF90_WRITE, id_set_xy(av) )
+             IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 20 )
+!
+!--          Read header information and set all ids. If there is a mismatch
+!--          between the previuos and the actual run, netcdf_extend is returned
+!--          as .FALSE.
+             CALL define_netcdf_header( 'xy', netcdf_extend, av )
 
 !
@@ -600,34 +775,30 @@
              IF ( .NOT. netcdf_extend )  THEN
                 nc_stat = NF90_CLOSE( id_set_xy(av) )
-                CALL netcdf_handle_error( 'check_open', 21 )
-                IF ( myid == 0 )  CALL local_system( 'rm ' // TRIM( filename ) )
-#if defined( __parallel )
-!
-!--             Set a barrier in order to assure that PE0 deleted the old file before any other
-!--             processor tries to open a new file.
-!--             Barrier is only needed in case of parallel I/O
-                IF ( netcdf_data_format > 4 )  CALL MPI_BARRIER( comm2d, ierr )
-#endif
-             ENDIF
-
-          ENDIF
+                IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 21 )
+                CALL local_system( 'rm ' // TRIM( filename ) )
+             ENDIF
+
+          ENDIF          
 
           IF ( .NOT. netcdf_extend )  THEN
 !
-!--          Create a new netCDF output file with requested netCDF format
-             CALL netcdf_create_file( filename, id_set_xy(av), .TRUE., 22 )
-
+!--          Create a new NetCDF output file
+             IF ( netcdf_64bit )  THEN
+#if defined( __netcdf_64bit )
+                nc_stat = NF90_CREATE( filename,                               &
+                                       OR( NF90_NOCLOBBER, NF90_64BIT_OFFSET ),&
+                                       id_set_xy(av) )
+#else
+                IF ( myid == 0 )  PRINT*, '+++ WARNING: NetCDF: no 64-bit ', &
+                                               'offset allowed on this machine'
+                nc_stat = NF90_CREATE( filename, NF90_NOCLOBBER, id_set_xy(av) )
+#endif
+             ELSE
+                nc_stat = NF90_CREATE( filename, NF90_NOCLOBBER, id_set_xy(av) )
+             ENDIF
+             IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 22 )
 !
 !--          Define the header
-             CALL netcdf_define_header( 'xy', netcdf_extend, av )
-
-!
-!--          In case of parallel netCDF output, create flag file which tells combine_plot_fields
-!--          that nothing is to do.
-             IF ( myid == 0  .AND.  netcdf_data_format > 4 )  THEN
-                OPEN( 99, FILE='NO_COMBINE_PLOT_FIELDS_XY' )
-                WRITE ( 99, '(A)' )  'no combine_plot_fields.x neccessary'
-                CLOSE( 99 )
-             ENDIF
+             CALL define_netcdf_header( 'xy', netcdf_extend, av )
 
           ENDIF
@@ -637,23 +808,26 @@
 !--       Set filename depending on unit number
           IF ( file_id == 102 )  THEN
-             filename = 'DATA_2D_XZ_NETCDF' // TRIM( coupling_char )
+             filename = 'DATA_2D_XZ_NETCDF'
              av = 0
           ELSE
-             filename = 'DATA_2D_XZ_AV_NETCDF' // TRIM( coupling_char )
+             filename = 'DATA_2D_XZ_AV_NETCDF'
              av = 1
           ENDIF
 !
-!--       Inquire, if there is a netCDF file from a previous run. This should be opened for
-!--       extension, if its dimensions and variables match the actual run.
+!--       Inquire, if there is a NetCDF file from a previuos run. This should
+!--       be opened for extension, if its dimensions and variables match the
+!--       actual run.
           INQUIRE( FILE=filename, EXIST=netcdf_extend )
 
           IF ( netcdf_extend )  THEN
 !
-!--          Open an existing netCDF file for output
-             CALL netcdf_open_write_file( filename, id_set_xz(av), .TRUE., 23 )
-!
-!--          Read header information and set all ids. If there is a mismatch between the previous
-!--          and the actual run, netcdf_extend is returned as .FALSE.
-             CALL netcdf_define_header( 'xz', netcdf_extend, av )
+!--          Open an existing NetCDF file for output 
+             nc_stat = NF90_OPEN( filename, NF90_WRITE, id_set_xz(av) )
+             IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 23 )
+!
+!--          Read header information and set all ids. If there is a mismatch
+!--          between the previuos and the actual run, netcdf_extend is returned
+!--          as .FALSE.
+             CALL define_netcdf_header( 'xz', netcdf_extend, av )
 
 !
@@ -661,34 +835,30 @@
              IF ( .NOT. netcdf_extend )  THEN
                 nc_stat = NF90_CLOSE( id_set_xz(av) )
-                CALL netcdf_handle_error( 'check_open', 24 )
-                IF ( myid == 0 )  CALL local_system( 'rm ' // TRIM( filename ) )
-#if defined( __parallel )
-!
-!--             Set a barrier in order to assure that PE0 deleted the old file before any other
-!--             processor tries to open a new file.
-!--             Barrier is only needed in case of parallel I/O
-                IF ( netcdf_data_format > 4 )  CALL MPI_BARRIER( comm2d, ierr )
-#endif
-             ENDIF
-
-          ENDIF
+                IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 24 )
+                CALL local_system( 'rm ' // TRIM( filename ) )
+             ENDIF
+
+          ENDIF          
 
           IF ( .NOT. netcdf_extend )  THEN
 !
-!--          Create a new netCDF output file with requested netCDF format
-             CALL netcdf_create_file( filename, id_set_xz(av), .TRUE., 25 )
-
+!--          Create a new NetCDF output file
+             IF ( netcdf_64bit )  THEN
+#if defined( __netcdf_64bit )
+                nc_stat = NF90_CREATE( filename,                               &
+                                       OR( NF90_NOCLOBBER, NF90_64BIT_OFFSET ),&
+                                       id_set_xz(av) )
+#else
+                IF ( myid == 0 )  PRINT*, '+++ WARNING: NetCDF: no 64-bit ', &
+                                               'offset allowed on this machine'
+                nc_stat = NF90_CREATE( filename, NF90_NOCLOBBER, id_set_xz(av) )
+#endif
+             ELSE
+                nc_stat = NF90_CREATE( filename, NF90_NOCLOBBER, id_set_xz(av) )
+             ENDIF
+             IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 25 )
 !
 !--          Define the header
-             CALL netcdf_define_header( 'xz', netcdf_extend, av )
-
-!
-!--          In case of parallel netCDF output, create flag file which tells combine_plot_fields
-!--          that nothing is to do.
-             IF ( myid == 0  .AND.  netcdf_data_format > 4 )  THEN
-                OPEN( 99, FILE='NO_COMBINE_PLOT_FIELDS_XZ' )
-                WRITE ( 99, '(A)' )  'no combine_plot_fields.x neccessary'
-                CLOSE( 99 )
-             ENDIF
+             CALL define_netcdf_header( 'xz', netcdf_extend, av )
 
           ENDIF
@@ -698,23 +868,26 @@
 !--       Set filename depending on unit number
           IF ( file_id == 103 )  THEN
-             filename = 'DATA_2D_YZ_NETCDF' // TRIM( coupling_char )
+             filename = 'DATA_2D_YZ_NETCDF'
              av = 0
           ELSE
-             filename = 'DATA_2D_YZ_AV_NETCDF' // TRIM( coupling_char )
+             filename = 'DATA_2D_YZ_AV_NETCDF'
              av = 1
           ENDIF
 !
-!--       Inquire, if there is a netCDF file from a previous run. This should be opened for
-!--       extension, if its dimensions and variables match the actual run.
+!--       Inquire, if there is a NetCDF file from a previuos run. This should
+!--       be opened for extension, if its dimensions and variables match the
+!--       actual run.
           INQUIRE( FILE=filename, EXIST=netcdf_extend )
 
           IF ( netcdf_extend )  THEN
 !
-!--          Open an existing netCDF file for output
-             CALL netcdf_open_write_file( filename, id_set_yz(av), .TRUE., 26 )
-!
-!--          Read header information and set all ids. If there is a mismatch between the previous
-!--          and the actual run, netcdf_extend is returned as .FALSE.
-             CALL netcdf_define_header( 'yz', netcdf_extend, av )
+!--          Open an existing NetCDF file for output 
+             nc_stat = NF90_OPEN( filename, NF90_WRITE, id_set_yz(av) )
+             IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 26 )
+!
+!--          Read header information and set all ids. If there is a mismatch
+!--          between the previuos and the actual run, netcdf_extend is returned
+!--          as .FALSE.
+             CALL define_netcdf_header( 'yz', netcdf_extend, av )
 
 !
@@ -722,34 +895,30 @@
              IF ( .NOT. netcdf_extend )  THEN
                 nc_stat = NF90_CLOSE( id_set_yz(av) )
-                CALL netcdf_handle_error( 'check_open', 27 )
-                IF ( myid == 0 )  CALL local_system( 'rm ' // TRIM( filename ) )
-#if defined( __parallel )
-!
-!--             Set a barrier in order to assure that PE0 deleted the old file before any other
-!--             processor tries to open a new file.
-!--             Barrier is only needed in case of parallel I/O
-                IF ( netcdf_data_format > 4 )  CALL MPI_BARRIER( comm2d, ierr )
-#endif
-             ENDIF
-
-          ENDIF
+                IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 27 )
+                CALL local_system( 'rm ' // TRIM( filename ) )
+             ENDIF
+
+          ENDIF          
 
           IF ( .NOT. netcdf_extend )  THEN
 !
-!--          Create a new netCDF output file with requested netCDF format
-             CALL netcdf_create_file( filename, id_set_yz(av), .TRUE., 28 )
-
+!--          Create a new NetCDF output file
+             IF ( netcdf_64bit )  THEN
+#if defined( __netcdf_64bit )
+                nc_stat = NF90_CREATE( filename,                               &
+                                       OR( NF90_NOCLOBBER, NF90_64BIT_OFFSET), &
+                                       id_set_yz(av) )
+#else
+                IF ( myid == 0 )  PRINT*, '+++ WARNING: NetCDF: no 64-bit ', &
+                                               'offset allowed on this machine'
+                nc_stat = NF90_CREATE( filename, NF90_NOCLOBBER, id_set_yz(av) )
+#endif
+             ELSE
+                nc_stat = NF90_CREATE( filename, NF90_NOCLOBBER, id_set_yz(av) )
+             ENDIF
+             IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 28 )
 !
 !--          Define the header
-             CALL netcdf_define_header( 'yz', netcdf_extend, av )
-
-!
-!--          In case of parallel netCDF output, create flag file which tells combine_plot_fields
-!--          that nothing is to do.
-             IF ( myid == 0  .AND.  netcdf_data_format > 4 )  THEN
-                OPEN( 99, FILE='NO_COMBINE_PLOT_FIELDS_YZ' )
-                WRITE ( 99, '(A)' )  'no combine_plot_fields.x neccessary'
-                CLOSE( 99 )
-             ENDIF
+             CALL define_netcdf_header( 'yz', netcdf_extend, av )
 
           ENDIF
@@ -757,20 +926,18 @@
        CASE ( 104 )
 !
-!--       Set filename
-          filename = 'DATA_1D_PR_NETCDF' // TRIM( coupling_char )
-
-!
-!--       Inquire, if there is a netCDF file from a previous run. This should be opened for
-!--       extension, if its variables match the actual run.
-          INQUIRE( FILE=filename, EXIST=netcdf_extend )
+!--       Inquire, if there is a NetCDF file from a previuos run. This should
+!--       be opened for extension, if its variables match the actual run.
+          INQUIRE( FILE='DATA_1D_PR_NETCDF', EXIST=netcdf_extend )
 
           IF ( netcdf_extend )  THEN
 !
-!--          Open an existing netCDF file for output
-             CALL netcdf_open_write_file( filename, id_set_pr, .FALSE., 29 )
-!
-!--          Read header information and set all ids. If there is a mismatch between the previous
-!--          and the actual run, netcdf_extend is returned as .FALSE.
-             CALL netcdf_define_header( 'pr', netcdf_extend, 0 )
+!--          Open an existing NetCDF file for output 
+             nc_stat = NF90_OPEN( 'DATA_1D_PR_NETCDF', NF90_WRITE, id_set_pr )
+             IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 29 )
+!
+!--          Read header information and set all ids. If there is a mismatch
+!--          between the previuos and the actual run, netcdf_extend is returned
+!--          as .FALSE.
+             CALL define_netcdf_header( 'pr', netcdf_extend, 0 )
 
 !
